/*
 *	main.c
 *
 *	HES Player
 *
 *	* Wed Feb 25 00:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define SPEED_TEST

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _HESINFO {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} HESINFO;

#define MAX_SONG	256			/* őȐ (1oCgR[hȂ̂ōőł0`255) */
typedef struct _SONGINFO {
	unsigned char code;			/* R[h */
	char name[128 - 1];			/* Ȗ */
} SONGINFO;
SONGINFO song_info[MAX_SONG];			/* ȃXg */
int num_song;					/* Ȑ */

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

HESINFO hes_info[MAXDIR];		/* HESt@CXg */
int hes_count;				/* HESt@C̐   */

int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */

const void* hes;			/* tHESt@C(tbVڎQ) */
int hes_len;				/* ̃TCY */

int track;				/* -1:t@CI[h/0`:݂̑IgbNԍ */
int playing;				/* 0:~/1:t */

int timer_limit;			/* ^C}~b^[1ɂȂ܂ */
int prev_timer_limit;			/* timer_limit̕ωop */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
int m3u_load(const char* fname);
void app_init();
void app_exit();
void schedule();
void file_sel();
void track_sel();
void disp();

/****************************************************************************
 *	main
 ****************************************************************************/

#ifndef SPEED_TEST
int
main()
{
	/* B */
	app_init();

	/* C[vB */
	track = -1;
	file_sel();

	return 0;
}
#endif /*SPEED_TEST*/

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	m3u_load
 ****************************************************************************/

int
m3u_load(const char* fname)
{
	char buf[256];
	int retval;
	int code;
	char* p;
	SONGINFO* si;
	//
	FILE* fp = NULL; /* G[̂߂NULLɏĂ܂ */

	/* ܂NAB */
	memset(song_info, 0, sizeof song_info);
	num_song = 0;

	/* M3Ut@C쐬܂B */
	strcpy(buf, fname);
	p = strchr(buf, '.');
	if(p) *p = '\0';
	strcat(buf, ".m3u");

	/* M3Ut@CJB */
	fp = fopen(buf, "rb");
	if(!fp) goto L_ERR;

	while(num_song < MAX_SONG) {
		/* sǂݍ݁B */
		p = fgets(buf, sizeof buf, fp);
		if(!p) break;

		/* Rgs? */
		if(buf[0] == '#') continue;

		/* śB */
		//[0] filenamehes::HES
		p = strtok(buf, ",");
		if(!p) continue;
		//[1] $??
		p = strtok(NULL, ",");
		if(!p) continue;
		retval = sscanf(p, "$%2X", &code);
		if(!retval) continue;
		//[2] songname
		p = strtok(NULL, ",");
		if(!p) continue;

		/* i[B */
		si = &song_info[num_song];
		si->code = code;
		strncpy(si->name, p, sizeof si->name - 1);
		si->name[sizeof si->name - 1] = '\0'; /* mɏI[ */
		num_song++;
	}
	if(!num_song) goto L_ERR; /* Ȃ΃G[ */

	/* M3Ut@CB */
	fclose(fp);
	fp = NULL;

	return 0; /*  */

L_ERR:
	/* t@CJĂB */
	if(fp) {
		fclose(fp);
		fp = NULL;
	}

	/* ̋ȃXg쐬B */
	for(code = 0; code < MAX_SONG; code++) {
		si = &song_info[code];
		si->code = code;
		sprintf(si->name, "Unknown%3d", code + 1);
	}
	num_song = MAX_SONG;

	return -1; /* s */
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
hes_info_compare(const void* _a, const void* _b)
{
	HESINFO* a = (HESINFO*)_a;
	HESINFO* b = (HESINFO*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	HESINFO* mi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(10/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* HESt@CT܂B */
	memset(hes_info, 0, sizeof hes_info);
	hes_count = 0;
	mi = &hes_info[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(hes_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".hes"łȂ΁A΂܂B */
		len = strlen(fi.filename);
		if(len < 3) continue;
		if(strcasecmp(&fi.filename[len - 4], ".hes") != 0) continue;
		/* t@CƃTCYi[܂B */
		if(len > MAXFILENAME) DIE();
		memcpy(mi->fname, fi.filename, len);
		mi->size = fi.length;
		hes_count++;
		mi++;
	}
	pceFileFindClose(&fi);
	if(hes_count == 0) {
		err_disp("HESt@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(hes_info, hes_count, sizeof(HESINFO), hes_info_compare);

	/* 48MHz/1WAIT */
	turbo(7);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	file_sel
 ****************************************************************************/

void
file_sel()
{
	HESINFO* mi;

	disp(); /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0            ) cursel--;
		if(joy & TRG_DN && cursel < hes_count - 1) cursel++;
		if(joy & TRG_LF) {
			cursel -= MAX_DISP;
			if(cursel < 0) cursel = 0;
		}
		if(joy & TRG_RI) {
			cursel += MAX_DISP;
			if(cursel > hes_count - 1) cursel = hes_count - 1;
		}
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĐJnH */
		if(joy & TRG_A) {
			hes_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			mi = &hes_info[cursel];
			hes = file_defrag(mi->fname, &hes_len);	/* t@C݂āA     */
			if(hes && memcmp(hes, "HESM", 4) == 0) {/* VOl`vA */
				track_sel();			/* gbNI[hցB   */
			} else {
				err_disp("̧ق͍Đł܂");
				/* p */
			}
		}

		/* ĕ`B */
		disp();
	}
}

/****************************************************************************
 *	track_sel
 ****************************************************************************/

void
track_sel()
{
	const HESHEADER* hdr = (HESHEADER*)hes;

	/* M3Ut@CȃXgǂݍ݁B */
	if(m3u_load(hes_info[cursel].fname) == 0) {
		/* M3UȃXgB */
		track = 0;
	} else {
		/* M3UȃXgȂB */
		track = hdr->start_song;
	}
	ASSERT(track < num_song);

	disp(); /* ͋` */
	for(;;) {
		schedule();

		/* ^C}~b^[Ԃωĕ`B */
		timer_limit = hes_timer_limit();
		if(prev_timer_limit != timer_limit) {
			prev_timer_limit = timer_limit;
			disp();
		}

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* gbNIύXH */
		if(joy & TRG_LF && track >            0) track--;
		if(joy & TRG_RI && track < num_song - 1) track++;
		if(joy & TRG_UP) {
			track -= 10;
			if(track < 0) track = 0;
		}
		if(joy & TRG_DN) {
			track += 10;
			if(track > num_song - 1) track = num_song - 1;
		}

		/* ĐJnH */
		if(joy & TRG_A) {
			playing = 1;
			if(hes_play(hes, hes_len, song_info[track].code) != 0) {
				playing = 0; /* YȂ!! */
				err_disp("̧ق͍Đł܂");
				break;
			}
		}

		/* ĐIort@CXg֔H */
		if(joy & TRG_B) {
			if(playing) {
				playing = 0;
				hes_stop();
			} else {
				break;
			}
		}

		/* ĕ`B */
		disp();
	}

	track = -1;
}

/****************************************************************************
 *	disp
 ****************************************************************************/

void
disp()
{
	int i, x, y, c, i_hes;
	HESINFO* mi;
	const HESHEADER* hdr;

	/* ʓ]B */
	draw = 1;

	/*----- t@CI[h -----*/

	/* t@CXg\B */
	memset(vbuff, 0, sizeof vbuff);
	mi = &hes_info[curtop];
	y = 8;
	for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
		i_hes = curtop + i;
		if(i_hes > hes_count - 1) break;
		if(i_hes == cursel) {
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
			c = 0;
		} else {
			c = 2;
		}
		render_string(&render, 4 + 4 *  1, y, mi->fname, 0x82, c);
		render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", mi->size);
		mi++;
		y += 6;
	}

	/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
	render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
	render_string(&render, 0, 1,
	//       0123456789012345678901234567890123
		"=========== HES Player ===========",
		0x82, 0);

	/* t@CI[hȂA܂ŁB */
	if(track < 0) return;

	/*----- gbNI[h -----*/

	if(!hes || memcmp(hes, "HESM", 4) != 0) return; /* Ô߁c */
	mi = &hes_info[cursel];
	hdr = (HESHEADER*)hes;

	x = 0;
	y = 8 + 6 * 2;
	render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 * 9 + 1, 3);
	render_string(&render, x + 4, y, "FileName:",                    0x82, 0);
	if(timer_limit) render_string(&render, x + 84, y, "TIMER LIMIT", 0x82, 0); y += 6;
	render_printf(&render, x + 8, y, 0x82, 1, "%s",                mi->fname); y += 6;
	render_string(&render, x + 4, y, "FileSize:",                    0x82, 0); y += 6;
	render_printf(&render, x + 8, y, 0x82, 1, "%12d",               mi->size); y += 6;
	render_string(&render, x + 4, y, "Track:",                       0x82, 0); y += 6;
	render_printf(&render, x + 8, y, 0x82, 1, "%8d/%3d", track + 1, num_song); y += 6;
	render_string(&render, x + 4, y, "SongName:",                    0x82, 0); y += 6;
	render_printf(&render, x + 8, y, 0x82, 1, "%s",    song_info[track].name); y += 6;
	if(playing) {
		render_string(&render, x + 4, y, "PLAYING...       A:PLAY/B:STOP", 0x82, 0); y += 6;
	} else {
		render_string(&render, x + 4, y, "                 A:PLAY/B:QUIT", 0x82, 0); y += 6;
	}
}

/****************************************************************************
 *	SPEED_TEST
 ****************************************************************************/

#ifdef SPEED_TEST
int
main()
{
	static HESDRIVER hes;
	static short wbuff[HESBUFLEN];

	const void* romp;
	int len, i, T0, T1;

	app_init();

	romp = file_defrag("kato_ken.hes", &len);
	if(!romp) DIE();
	if(hes_init(&hes, romp, len, 0) != 0) DIE();
	T0 = pceTimerGetCount();
	for(i = 0; i < SPEAKER_FREQUENCY / HESBUFLEN * 1; i++) {
		hes_stream_callback(wbuff, (int)&hes);
	}
	T1 = pceTimerGetCount();
	pceFontSetPos(0, 0);
	pceFontPrintf("%d\n", T1 - T0);
	for(;;) {
		schedule();
	}

	return 0;
}
#endif /*SPEED_TEST*/
